package ejem05;

import java.awt.*;
import java.applet.*;
import java.awt.event.*;

import ejem02.*;

public class ejerc054 extends Applet implements ItemListener,ActionListener{
	
	List laLista;
	TextField elTextField;
	Button bAgregar,bQuitar,bLimpiar;
	Checkbox cbMultiSel;
	CheckboxGroup g=new CheckboxGroup();
	Checkbox creciente,decreciente;
	
	
	public void init() {
		setBackground(Color.red);
		GridBagLayout gbl=new GridBagLayout();
		setLayout(gbl);
		GridBagConstraints c=new GridBagConstraints();
		
		add(bAgregar=new Button("Agregar"));	
		add(bQuitar=new Button("Quitar"));	
		add(bLimpiar=new Button("Limpiar"));	
		add(laLista=new List(1,true));	
		add(elTextField=new TextField("Holas"));	
		add(cbMultiSel = new Checkbox("Multiseleccion",true));

		add(creciente=new Checkbox("creciente",g,true));
		add(decreciente=new Checkbox("decresiente",g,false));
		
		

		c.insets=new Insets(0,2,4,8);

		c.anchor=GridBagConstraints.CENTER;
		c.fill  =GridBagConstraints.BOTH;
		c.gridwidth=1; c.gridheight=1; 
		c.weightx=1; c.weighty=1;
		c.gridx=3; c.gridy=0; gbl.setConstraints(bAgregar,c);
		c.gridx=4; c.gridy=0; gbl.setConstraints(bQuitar,c);
		c.gridwidth=2; c.gridx=3; c.gridy=1; gbl.setConstraints(bLimpiar,c);
		
		c.gridheight=2;
		c.weighty=8; c.gridwidth=2; c.gridx=1; c.gridy=2; gbl.setConstraints(laLista,c);
		c.weighty=1; c.gridwidth=1; c.gridx=4; c.gridy=2; gbl.setConstraints(elTextField,c);
		c.weighty=1; c.gridwidth=1; c.gridx=4; c.gridy=4; gbl.setConstraints(cbMultiSel,c);

		c.weighty=1; c.gridwidth=1; c.gridx=3; c.gridy=6; gbl.setConstraints(creciente,c);
		c.weighty=1; c.gridwidth=1; c.gridx=4; c.gridy=6; gbl.setConstraints(decreciente,c);
		
		laLista.addItemListener(this);		
		bAgregar.addActionListener(this);
		bQuitar.addActionListener(this);
		bLimpiar.addActionListener(this);
		cbMultiSel.addItemListener(this);
		creciente.addItemListener(this);
		decreciente.addItemListener(this);
		
	}
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==bAgregar){

			if(elTextField.getText().length()>0){
				
				
				if(laLista.getItemCount()>0){
					/*agregar el nuevo*/
					laLista.add(elTextField.getText());	
					
					
					ordenaLista();					
					
				}
				else
					laLista.add(elTextField.getText());	
					
				elTextField.setText("");
			}
		}
		else if(e.getSource()==bQuitar){
			
			int[] si =laLista.getSelectedIndexes();
			while(si.length>0){
				laLista.delItem(si[0]);
				si =laLista.getSelectedIndexes();
			}
		}
		else if(e.getSource()==bLimpiar){
			laLista.removeAll();
		}
	}
	
	public void itemStateChanged(ItemEvent e) {
		if(e.getSource()==cbMultiSel){
			if(cbMultiSel.getState()){
				laLista.setMultipleMode(true);	
			}
			else
				laLista.setMultipleMode(false);
		}
		else if(e.getSource()==creciente || e.getSource()==decreciente){
			ordenaLista();
		}
	}

	public void ordenaLista(){
		/*obtener los que hay*/
		String[] Ia= laLista.getItems();
		/*ordenar*/
		OrdenaCadenas oc=new OrdenaCadenas();
		insercionDirectaBis idb= new insercionDirectaBis(Ia,oc);
		idb.ordena();
		
		/*limpiar la lista*/
		laLista.removeAll();
		
		/*agregar*/
		if(creciente.getState()){
			/*creciente*/
			for(int i=0;i<Ia.length;i++){
				laLista.add(Ia[i]);	
			}
		}
		else{
			/*decresiente*/
			for(int i=Ia.length-1;i>=0;i--){
				laLista.add(Ia[i]);	
			}
		}
		
	}
	public void paint(Graphics g) {
	}
}
